package tictactoe;

import io.sockit.gameserver.DefaultWebHandler;
import io.sockit.gameserver.LevelDbStore;
import io.sockit.gameserver.Server;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;

public class Main {
    public static void main(String[] args) throws Exception{
        File webRootFolder=getWebFolder();
        //set the Server database
        Server.setDataStore(new LevelDbStore("../gameDB"));
        //allow Login to be Combined with Register User 
        Server.setCombineLoginWithRegisterUser(true);
        //Register the TicTacToe game
        Server.registerGame(new TicTacToeGame());
        //Set the server's web handler
        Server.setWebHandler(new DefaultWebHandler(webRootFolder));
        //start the server without ssl on the default http port
        Server.startServerAsHttp(0); 
        Server.logToConsole("type localhost in your browser's address bar to run the web client");
    }
    
    static File getWebFolder() throws Exception{
        //create web folder in current directory
        File webFolder=new File("./web");
        webFolder.mkdir();
        //copy TicTacToe web files to the web folder
        copy(Main.class.getResourceAsStream("/web/SocKitClient-1.0.min.js"), "SocKitClient-1.0.min.js", webFolder);
        copy(Main.class.getResourceAsStream("/web/TicTacToe.js"), "TicTacToe.js", webFolder);
        copy(Main.class.getResourceAsStream("/web/index.html"), "index.html", webFolder);
        copy(Main.class.getResourceAsStream("/web/styles.css"), "styles.css", webFolder);
        return webFolder;
    }
    
    static void copy(InputStream inputStream,String filename,File destFolder) throws Exception{
        BufferedInputStream bis=new BufferedInputStream(inputStream);
        BufferedOutputStream bos=new BufferedOutputStream(new FileOutputStream(new File(destFolder,filename)));
        int charRead;
        while((charRead=bis.read())>=0)
            bos.write(charRead);
        bos.close();
        bis.close();
    }
}
